#!/bin/sh

# This Interarchy file converter is released in the Public Domain by Nolobe
# Comments or bug reports can be sent to <support@nolobe.com>

# usage:
# converter -U readonlyfile tempfile
# display "OK" or display an error message
# converter -D readonlyfile newfile
# display "OK" or display an error message

function usage () { 
	echo "Usage: convert-gz [-U|-D] source dest" > /dev/stderr
	exit 1
}

if [[ "$2" == "" || "$3" == "" ]]; then
	usage
fi
if [[ "$1" != "-U" && "$1" != "-D" ]]; then
	usage
fi

if [[ ! -r "$2" || ! -f "$2" ]]; then
	echo "Source file '$2' not readable" > /dev/stderr
	exit 2
fi

if [ "$1" == "-U" ]; then

	if gzip --quiet --stdout "$2" > "$3"; then
		exit 0
	else
		e=$?
		echo "gzip failed" > /dev/stderr
		exit $e
	fi

elif [ "$1" == "-D" ]; then

	if gunzip --quiet --stdout "$2" > "$3"; then
		exit 0
	else
		e=$?
		echo "gunzip failed" > /dev/stderr
		exit $e
	fi

else
	usage
fi
