#use strict;
#use warnings;
$|=1;
binmode STDIN;
binmode STDOUT;
reset_timeout();
our $id = 1;
result( good("PV:$]") );
$id++;
our $sentend = 0;
while ( 1 ) {
	my $code;
	if ( !full_sysread( \$code, 2 ) ) {
		final_result( err() );
	}
	my $len = unpack( "n", $code );
	if ( !$len ) {
		final_result( good() );
	}
	if ( !full_sysread( \$code, $len ) ) {
		final_result( err() );
	}
	my $result = eval $code;
	if ( ($result || 0) != 1234 ) {
		final_result( err( $@ ) );
	}
	$id++;
}

sub final_result {
	my( $e ) = @_;
	result( $e );
	$sentend = 1;
	exit();
}

sub END {
	result( err('Failed '.($!||'')) ) unless $sentend;
}

sub encode {
	my $what = $_[0];
	$what =~ s!([^A-Za-z0-9./+\-_])!sprintf( "\\%03o", ord($1) )!ge;
	return $what;
}

sub encode_percent {
	my $what = $_[0];
	$what =~ s!([^A-Za-z0-9./+\-_])!sprintf( "%%%02X", ord($1) )!ge;
	return $what;
}

sub decode {
	my $what = $_[0];
	$what =~ s!\\([0-7]{3})!chr( oct( $1 ) )!ge;
	return $what;
}

sub err {
	my ( $e ) = @_;
	$e ||= $!;
	$e ||= 'Unknown';
	$e =~ tr!\000- ! !;
	return 'E'.substr( $e, 0, 2500 );
}

sub good {
	my ( $e ) = @_;
	$e ||= '';
	$e =~ tr!\000- ! !;
	return 'G'.substr( $e, 0, 2500 );
}

sub output {
	my ( $what ) = @_;
	reset_timeout();
	print pack( "n", length( $what ) ), $what;
}

sub result {
	my( $e ) = @_;
	output( "$id:$e" );
	return 1234;
}

sub reset_timeout {
	alarm(300);
}

sub full_sysread {
	my ( $what, $len ) = @_;
	$$what = '';
	while ( $len > 0 ) {
		my $readlen = sysread( STDIN, $$what, $len, length( $$what ) );
		if ( !$readlen ) {
			$$what = '';
			return 0;
		}
		$len -= $readlen;
	}
	return length( $$what );
}

__END__

