sub com_nolobe_interarchy_ssh_list {
	my ( $file, $recursive ) = @_;
	
	my( %uids, %gids );
	my $buffer = '';
	my $d = do_list_send_init();
	
	my $result;
	if ( chdir( $file ) ) {
		my @dirs = ( '.' );
		while ( !$result && @dirs ) {
			my $dir = shift @dirs;
			if ( $recursive ) {
				$result = do_list_send_chunk( \$buffer, $d, encode( $dir ).":\n" );
			}
			if ( opendir( DIR, $dir ) ) {
				foreach ( readdir( DIR ) ) {
					s!.*/!!;
					next if $_ eq '.' || $_ eq '..';
					my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
						$atime,$mtime,$ctime,$blksize,$blocks)
								= lstat("$dir/$_");
					next unless defined( $mode );
					push @dirs, "$dir/$_" if $recursive && -d _;
					my $line = '';
					if ( -d _ ) {
						$line = 'd';
						$size = 0;
					} elsif ( -l _ ) {
						$line = 'l';
						$size = 0;
					} else {
						$line = '-';
					}
					my @perms = ('---','--x','-w-','-wx','r--','r-x','rw-','rwx');
					$line .= $perms[($mode & 0700) >> 6].$perms[($mode & 0070) >> 3].$perms[$mode & 0007];
					my $uname;
					if ( defined $uids{$uid} ) {
						$uname = $uids{$uid};
					} else {
						($uname) = getpwuid( $uid );
					}
					$uname = $uid unless defined $uname;
					$uname = '-' unless defined $uname && $uname ne '';
					$uids{$uid} = $uname;
					my $gname;
					if ( defined $gids{$gid} ) {
						$gname = $gids{$gid};
					} else {
						($gname) = getgrgid( $gid );
					}
					$gname = $gid unless defined $gname;
					$gname = '-' unless defined $gname && $gname ne '';
					$gids{$gid} = $gname;
					$mtime ||= '-';
					$line .= sprintf( " PS %-8s %-8s %12u %08X %s\n", encode_percent($uname), encode_percent($gname), $size, $mtime, encode_percent($_) );
					$result = do_list_send_chunk( \$buffer, $d, $line );
					last if $result;
				}
			} else {
				$result = err();
				last;
			}
			$result ||= do_list_send_chunk( \$buffer, $d, "\n" );
		}
	} else {
		$result = err();
	}
	$result ||= do_list_send_chunk( \$buffer, $d, '', 1 );
	$result ||= good();
	output( '' );
	result( $result );
}

sub do_list_send_init {
	my $d;
	if ( eval( 'require Compress::Zlib' ) ) {
		my $status;
		($d, $status) = Compress::Zlib::deflateInit( Level => 1 ); # Z_BEST_SPEED
	}
	if ( $d ) {
		output( "C" );
	} else {
		output( "U" );
	}
	return $d;
}

sub do_list_send_chunk {
	my ( $buffer, $d, $what, $flush ) = @_;
	
	if ( !$d ) {
		$$buffer .= $what;
	} else {
		my ($out, $status) = $d->deflate( $what );
		if ( $flush && defined( $out ) ) {
			my $out2;
			($out2, $status) = $d->flush();
			if ( defined( $out2 ) ) {
				$out .= $out2;
			} else {
				$out = undef;
			}
		}
		if ( defined( $out ) ) {
			$$buffer .= $out;
		} else {
			return err($status);
		}
	}
	return unless $flush || length( $$buffer ) >= 10240;
	return if length( $$buffer ) == 0;
	if ( length( $$buffer ) < 15000 ) {
			output( $$buffer );
	} else {
		my $p = 0;
		while ( $p < length( $$buffer ) ) {
			my $c = length( $$buffer ) - $p;
			$c = 10240 if $c > 15000;
			output( substr( $$buffer, $p, $c ) );
			$p += $c;
		}
	}
	$$buffer = '';
	return;
}

